-module(glychee@benchmark).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([run/2]).
-export_type([function_/2, data/1]).

-type function_(Z, AA) :: {function, binary(), fun((Z) -> fun(() -> AA))}.

-type data(AB) :: {data, binary(), AB}.

-spec run(list(function_(AC, any())), list(data(AC))) -> nil.
run(Function_list, Data_list) ->
    glychee@internal@lib:gleam_list_each(
        Data_list,
        fun(Data) ->
            io:put_chars(<<"\n\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                    "\n"/utf8>>
            ),
            io:put_chars(
                <<"==== data set: "/utf8, (erlang:element(2, Data))/binary>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                    "\n"/utf8>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            _pipe = Function_list,
            _pipe@1 = glychee@internal@lib:gleam_list_map(
                _pipe,
                fun(Function) ->
                    {erlang:element(2, Function),
                        (erlang:element(3, Function))(erlang:element(3, Data))}
                end
            ),
            'Elixir.GlycheeBenchee':run(_pipe@1)
        end
    ).
