-module(glychee@internal@lib).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([gleam_list_each/2, gleam_io_println/1, gleam_list_map/2]).

-spec gleam_list_each(list(I), fun((I) -> any())) -> nil.
gleam_list_each(List, F) ->
    case List of
        [] ->
            nil;

        [X | Xs] ->
            F(X),
            gleam_list_each(Xs, F)
    end.

-spec gleam_io_println(binary()) -> nil.
gleam_io_println(Text) ->
    io:put_chars(Text).

-spec gleam_list_map(list(L), fun((L) -> N)) -> list(N).
gleam_list_map(List, Callable) ->
    lists:map(Callable, List).
